(name,Pocket Rect, 1)
(dlg,Position X, 3, 0, -10000, 10000)
(dlg,Position Y, 3, 0, -10000, 10000)
(dlg,Position Z, 3, 0, -10000, 10000)
(dlg,Size X, 3, 40, 0, 10000)
(dlg,Size Y, 3, 30, 0, 10000)
(dlg,Tool Diameter, 3, 6, 0, 1000)
(dlg,Tool Stepover, 3, 0.4, 0.001, 1)
(dlg,Depth, 3, 12, 0, 1000)
(dlg,Pass Depth, 3, 1, 0.001, 1000)
(dlg,Plunge Speed, 2, 100, 0.01, 10000)

#<delta> = [#<_pocket_rect-tool_diameter> * #<_pocket_rect-tool_stepover>]
o100 if[#<delta> GE #<_pocket_rect-size_x>]
  (print,Size X is too small)
  M2
o100 endif

o100 if[#<delta> GE #<_pocket_rect-size_y>]
  (print,Size Y is too small)
  M2
o100 endif

M70
G90 (absolute mode)
G94 (units per minute mode)

#<start_x> = #<_x>
#<start_y> = #<_y>
#<start_z> = #<_z>
#<start_feed> = #<_feedspeed>

#<straight_x> = 0
#<straight_y> = 0
o100 if[#<_pocket_rect-size_x> GT #<_pocket_rect-size_y>]
  #<size_max> = #<_pocket_rect-size_x>
  #<size_min> = #<_pocket_rect-size_y>
  #<straight_x> = [[#<size_max> - #<size_min>] / 2]
o100 endif
o100 if[#<_pocket_rect-size_x> LT #<_pocket_rect-size_y>]
  #<size_max> = #<_pocket_rect-size_y>
  #<size_min> = #<_pocket_rect-size_x>
  #<straight_y> = [[#<size_max> - #<size_min>] / 2]
o100 endif

#<px> = [#<_pocket_rect-position_x> + #<straight_x>]
#<py> = [#<_pocket_rect-position_y> + #<straight_y>]
#<pz> = #<_pocket_rect-position_z>

G00 X#<_pocket_rect-position_x> Y#<_pocket_rect-position_y>
G00 X#<px> Y#<py>
G00 Z#<pz>

o100 while[#<pz> GT [-1 * #<_pocket_rect-depth>]]
  #<px> = [#<_pocket_rect-position_x> + #<straight_x>]
  #<py> = [#<_pocket_rect-position_y> + #<straight_y>]

  #<pz> = [#<pz> - #<_pocket_rect-pass_depth>]
  o200 if[#<pz> LT [-1 * #<_pocket_rect-depth>]]
    #<pz> = [-1 * #<_pocket_rect-depth>]
  o200 endif

  F#<_pocket_rect-plunge_speed>
  G01 Z#<pz>

  F#<start_feed>

  #<cnt> = 0
  #<cont_x> = 1
  #<cont_y> = 1
  o300 while[#<cont_x> OR #<cont_y>]

    o400 if[#<cnt> EQ 0]
      #<delta_x> = [#<delta> / 2]
      #<delta_y> = [#<delta> / 2]
    o400 else	
      #<delta_x> = #<delta>
      #<delta_y> = #<delta>
    o400 endif

    o400 if[ [#<px> + #<delta_x>] GT [#<_pocket_rect-position_x> + #<_pocket_rect-size_x>/2 - #<_pocket_rect-tool_diameter>/2] ]
      #<cont_x> = 0
      #<delta_x> = [[#<_pocket_rect-position_x> + #<_pocket_rect-size_x>/2 - #<_pocket_rect-tool_diameter>/2] - #<px>]
    o400 endif

    o400 if[ [#<py> + #<delta_y>] GT [#<_pocket_rect-position_y> + #<_pocket_rect-size_y>/2 - #<_pocket_rect-tool_diameter>/2] ]
      #<cont_y> = 0
      #<delta_y> = [[#<_pocket_rect-position_y> + #<_pocket_rect-size_y>/2 - #<_pocket_rect-tool_diameter>/2] - #<py>]
    o400 endif

    ;diagonal
    #<px> = [#<px> + #<delta_x>]
    #<py> = [#<py> + #<delta_y>]
    G01 X#<px> Y#<py>

    ;down
    #<py> = [#<py> - [2 * #<delta_y> + 2 * #<straight_y>]]
    o400 if[#<cnt> GT 0]
      #<py> = [#<py> - [[2 * #<cnt> - 1] * #<delta>]]
    o400 endif
    G01 X#<px> Y#<py>

    ;left
    #<px> = [#<px> - [2 * #<delta_x> + 2 * #<straight_x>]]
    o400 if[#<cnt> GT 0]
      #<px> = [#<px> - [[2 * #<cnt> - 1] * #<delta>]]
    o400 endif
    G01 X#<px> Y#<py>

    ;up
    #<py> = [#<py> + [2 * #<delta_y> + 2 * #<straight_y>]]
    o400 if[#<cnt> GT 0]
      #<py> = [#<py> + [[2 * #<cnt> - 1] * #<delta>]]
    o400 endif
    G01 X#<px> Y#<py>

    ;right
    #<px> = [#<px> + [2 * #<delta_x> + 2 * #<straight_x>]]
    o400 if[#<cnt> GT 0]
      #<px> = [#<px> + [[2 * #<cnt> - 1] * #<delta>]]
    o400 endif
    G01 X#<px> Y#<py>

    #<cnt> = [#<cnt> + 1]
  o300 endwhile
o100 endwhile

G00 Z#<start_z>
G00 X#<start_x> Y#<start_y>
M72
M02
