M70 (store state)
G90 (absolute mode)
G94 (units per minute mode)
F#<_speed_home> (set home speed)

#<axis>=1
o<loop> while [#<axis> LE 9]

  o<ordx> if [#<_home_order_x> EQ #<axis>]
    o<dirx> if [#<_home_dir_x> GT +0.5]
      o<checkpin> if [#<_limit_xp_pin> EQ 0]
        (msgdlg,Limit switch X+ is not configured)
        M2
      o<checkpin> endif
      G38.1 X+10 (home X axis)
      G10 L9 X[#<_motorlimit_xp> + #<_homeswitch_hysteresis>] (set absolute X)
      G53 G0 X[#<_home_pos_x>] (move to home)
    o<dirx> elseif [#<_home_dir_x> LT -0.5]
      o<checkpin> if [#<_limit_xm_pin> EQ 0]
        (msgdlg,Limit switch X- is not configured)
        M2
      o<checkpin> endif
      G38.1 X-10 (home X axis)
      G10 L9 X[#<_motorlimit_xm> - #<_homeswitch_hysteresis>] (set absolute X)
      G53 G0 X[#<_home_pos_x>] (move to home)
    o<dirx> endif
  o<ordx> endif

  o<ordy> if [#<_home_order_y> EQ #<axis>]
    o<diry> if [#<_home_dir_y> GT +0.5]
      o<checkpin> if [#<_limit_yp_pin> EQ 0]
        (msgdlg,Limit switch Y+ is not configured)
        M2
      o<checkpin> endif
      G38.1 Y+10 (home Y axis)
      G10 L9 Y[#<_motorlimit_yp> + #<_homeswitch_hysteresis>] (set absolute Y)
      G53 G0 Y[#<_home_pos_y>] (move to home)
    o<diry> elseif [#<_home_dir_y> LT -0.5]
      o<checkpin> if [#<_limit_ym_pin> EQ 0]
        (msgdlg,Limit switch Y- is not configured)
        M2
      o<checkpin> endif
      G38.1 Y-10 (home Y axis)
      G10 L9 Y[#<_motorlimit_ym> - #<_homeswitch_hysteresis>] (set absolute Y)
      G53 G0 Y[#<_home_pos_y>] (move to home)
    o<diry> endif
  o<ordy> endif

  o<ordz> if [#<_home_order_z> EQ #<axis>]
    o<dirz> if [#<_home_dir_z> GT +0.5]
      o<checkpin> if [#<_limit_zp_pin> EQ 0]
        (msgdlg,Limit switch Z+ is not configured)
        M2
      o<checkpin> endif
      G38.1 Z+10 (home Z axis)
      G10 L9 Z[#<_motorlimit_zp> + #<_homeswitch_hysteresis>] (set absolute Z)
      G53 G0 Z[#<_home_pos_z>] (move to home)
    o<dirz> elseif [#<_home_dir_z> LT -0.5]
      o<checkpin> if [#<_limit_zm_pin> EQ 0]
        (msgdlg,Limit switch Z- is not configured)
        M2
      o<checkpin> endif
      G38.1 Z-10 (home Z axis)
      G10 L9 Z[#<_motorlimit_zm> - #<_homeswitch_hysteresis>] (set absolute Z)
      G53 G0 Z[#<_home_pos_z>] (move to home)
    o<dirz> endif
  o<ordz> endif

  o<orda> if [#<_home_order_a> EQ #<axis>]
    o<dira> if [#<_home_dir_a> GT +0.5]
      o<checkpin> if [#<_limit_ap_pin> EQ 0]
        (msgdlg,Limit switch A+ is not configured)
        M2
      o<checkpin> endif
      G38.1 A+10 (home A axis)
      G10 L9 A[#<_motorlimit_ap> + #<_homeswitch_hysteresis>] (set absolute A)
      G53 G0 A[#<_home_pos_a>] (move to home)
    o<dira> elseif [#<_home_dir_a> LT -0.5]
      o<checkpin> if [#<_limit_am_pin> EQ 0]
        (msgdlg,Limit switch A- is not configured)
        M2
      o<checkpin> endif
      G38.1 A-10 (home A axis)
      G10 L9 A[#<_motorlimit_am> - #<_homeswitch_hysteresis>] (set absolute A)
      G53 G0 A[#<_home_pos_a>] (move to home)
    o<dira> endif
  o<orda> endif

  o<ordb> if [#<_home_order_b> EQ #<axis>]
    o<dirb> if [#<_home_dir_b> GT +0.5]
      o<checkpin> if [#<_limit_bp_pin> EQ 0]
        (msgdlg,Limit switch B+ is not configured)
        M2
      o<checkpin> endif
      G38.1 B+10 (home B axis)
      G10 L9 B[#<_motorlimit_bp> + #<_homeswitch_hysteresis>] (set absolute B)
      G53 G0 B[#<_home_pos_b>] (move to home)
    o<dirb> elseif [#<_home_dir_b> LT -0.5]
      o<checkpin> if [#<_limit_bm_pin> EQ 0]
        (msgdlg,Limit switch B- is not configured)
        M2
      o<checkpin> endif
      G38.1 B-10 (home B axis)
      G10 L9 B[#<_motorlimit_bm> - #<_homeswitch_hysteresis>] (set absolute B)
      G53 G0 B[#<_home_pos_b>] (move to home)
    o<dirb> endif
  o<ordb> endif

  o<ordc> if [#<_home_order_c> EQ #<axis>]
    o<dirc> if [#<_home_dir_c> GT +0.5]
      o<checkpin> if [#<_limit_cp_pin> EQ 0]
        (msgdlg,Limit switch C+ is not configured)
        M2
      o<checkpin> endif
      G38.1 C+10 (home C axis)
      G10 L9 C[#<_motorlimit_cp> + #<_homeswitch_hysteresis>] (set absolute C)
      G53 G0 C[#<_home_pos_c>] (move to home)
    o<dirc> elseif [#<_home_dir_c> LT -0.5]
      o<checkpin> if [#<_limit_cm_pin> EQ 0]
        (msgdlg,Limit switch C- is not configured)
        M2
      o<checkpin> endif
      G38.1 C-10 (home C axis)
      G10 L9 C[#<_motorlimit_cm> - #<_homeswitch_hysteresis>] (set absolute C)
      G53 G0 C[#<_home_pos_c>] (move to home)
    o<dirc> endif
  o<ordc> endif

  o<ordu> if [#<_home_order_u> EQ #<axis>]
    o<diru> if [#<_home_dir_u> GT +0.5]
      o<checkpin> if [#<_limit_up_pin> EQ 0]
        (msgdlg,Limit switch U+ is not configured)
        M2
      o<checkpin> endif
      G38.1 U+10 (home U axis)
      G10 L9 U[#<_motorlimit_up> + #<_homeswitch_hysteresis>] (set absolute U)
      G53 G0 U[#<_home_pos_u>] (move to home)
    o<diru> elseif [#<_home_dir_u> LT -0.5]
      o<checkpin> if [#<_limit_um_pin> EQ 0]
        (msgdlg,Limit switch U- is not configured)
        M2
      o<checkpin> endif
      G38.1 U-10 (home U axis)
      G10 L9 U[#<_motorlimit_um> - #<_homeswitch_hysteresis>] (set absolute U)
      G53 G0 U[#<_home_pos_u>] (move to home)
    o<diru> endif
  o<ordu> endif

  o<ordv> if [#<_home_order_v> EQ #<axis>]
    o<dirv> if [#<_home_dir_v> GT +0.5]
      o<checkpin> if [#<_limit_vp_pin> EQ 0]
        (msgdlg,Limit switch V+ is not configured)
        M2
      o<checkpin> endif
      G38.1 V+10 (home V axis)
      G10 L9 V[#<_motorlimit_vp> + #<_homeswitch_hysteresis>] (set absolute V)
      G53 G0 V[#<_home_pos_v>] (move to home)
    o<dirv> elseif [#<_home_dir_v> LT -0.5]
      o<checkpin> if [#<_limit_vm_pin> EQ 0]
        (msgdlg,Limit switch V- is not configured)
        M2
      o<checkpin> endif
      G38.1 V-10 (home V axis)
      G10 L9 V[#<_motorlimit_vm> - #<_homeswitch_hysteresis>] (set absolute V)
      G53 G0 V[#<_home_pos_v>] (move to home)
    o<dirv> endif
  o<ordv> endif

  o<ordw> if [#<_home_order_w> EQ #<axis>]
    o<dirw> if [#<_home_dir_w> GT +0.5]
      o<checkpin> if [#<_limit_wp_pin> EQ 0]
        (msgdlg,Limit switch W+ is not configured)
        M2
      o<checkpin> endif
      G38.1 W+10 (home W axis)
      G10 L9 W[#<_motorlimit_wp> + #<_homeswitch_hysteresis>] (set absolute W)
      G53 G0 W[#<_home_pos_w>] (move to home)
    o<dirw> elseif [#<_home_dir_w> LT -0.5]
      o<checkpin> if [#<_limit_wm_pin> EQ 0]
        (msgdlg,Limit switch W- is not configured)
        M2
      o<checkpin> endif
      G38.1 W-10 (home W axis)
      G10 L9 W[#<_motorlimit_wm> - #<_homeswitch_hysteresis>] (set absolute W)
      G53 G0 W[#<_home_pos_w>] (move to home)
    o<dirw> endif
  o<ordw> endif

  #<axis> = [#<axis> + 1]
o<loop> endwhile
M72 (restore state)
M2
